class Tree {
    private Tree left, right;
    int val;
    
    public static void main(String args[]) {
    	int n_iter = 10;
		Tree t = new Tree(0, null, null);
		System.out.println(t);
		System.out.println(t.expand().expand());
		for (int j=0; j<n_iter; j++){
			System.out.println("Iteration " + (j+1) + "/" + n_iter);
		    t = new Tree(0, null, null);
		    for (int i=0; i<20; i++){
			t = t.expand();
		    }
		}
    }

    public Tree(int val, Tree left, Tree right){
		this.left = left;
		this.right = right;
		this.val = val;
    }
	
    public Tree expand(){
    	return new Tree(val+1, clone(), clone());
    }
    
    public Tree clone(){
    	return new Tree(val,
			left == null ? null : left.clone(),
			right == null ? null : right.clone());
    }
    
    public String toString(){
    	return "{ " + val + " , " + (left == null ? "{}" : left.toString()) +
	    " , " + (right == null ? "{}" : right.toString()) + " }";
    }
}
